# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without integration

# use pre-build jboss-test jar in bootstrap mode
#%bcond_with bootstrap

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/microcontainer/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define oname jboss-microcontainer
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           jboss-microcontainer2
Version:        2.0.10
Release:        5%{?dist}
Epoch:          0
Summary:        JBoss Microcontainer
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/microcontainer/tags/2.0.10.GA/ jboss-microcontainer-2.0.10
# Exported revision 105250.
# tar czf jboss-microcontainer-2.0.10.tar.gz jboss-microcontainer-2.0.10
Source0:        jboss-microcontainer-2.0.10.tar.gz
Source1:        jboss-microcontainer-jpp-depmap.xml
Source2:        jboss-microcontainer-settings.xml
Source3:        jboss-microcontainer-component-info.xml

#%if %with bootstrap
#Source4:        jboss-test-1.1.4.jar
#%endif

Patch0:         jboss-microcontainer-kernel-pom.patch
Patch1:         jboss-microcontainer-pom.patch
Patch2:         jboss-microcontainer-wo-int.patch
Patch3:		jboss-microcontainer-pom-findbugs.patch
Patch4:         jboss-microcontainer-jboss-parent.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-enforcer-rule-api
BuildRequires:	maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  jboss-test
BuildRequires:  ant-junit
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  jboss-common-logging-log4j
BuildRequires:	jboss-parent
BuildRequires:	jboss-profiler 
BuildRequires:  jboss-naming
BuildRequires:  jboss-man
BuildRequires:  jboss-mdr
BuildRequires:  jbossxb2
%if %with integration
BuildRequires:  gnu-trove
BuildRequires:  google-guice
BuildRequires:  jboss-aop2
%endif

Requires:  jboss-common-logging-log4j
Requires:  jboss-man
Requires:  jboss-mdr
Requires:  jbossxb2
%if %with integration
Requires:  jboss-aop2
%endif

Obsoletes:      jboss-microcontainer <= 1:1.0.2

%description
JBoss microcontainer.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{oname}-%{version}
%patch0 -b .sav0
%if %without integration
%patch2 -b .sav2
%else
%patch1 -b .sav1
%endif
%patch3 -p1 -b .sav3
%patch4 -p1 -b .sav4
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

#%if %with bootstrap
#mkdir -p ${MAVEN_REPO_LOCAL}/org/jboss/test/jboss-test/1.1.1.GA
#cp -pr %{SOURCE4} ${MAVEN_REPO_LOCAL}/org/jboss/test/jboss-test/1.1.1.GA/jboss-test-1.1.1.GA.jar
#%endif

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dskip-enforce \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        javadoc:aggregate 

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 644 kernel/target/jboss-kernel.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-kernel-%{version}.jar
install -p -m 644 kernel/target/jboss-kernel-tests.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-kernel-tests-%{version}.jar
install -p -m 644 dependency/target/jboss-dependency.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-dependency-%{version}.jar

%if %with integration
install -p -m 644 aop-mc-int/target/jboss-aop-mc-int.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-mc-int-%{version}.jar
install -p -m 644 guice-int/target/jboss-guice-int.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-guice-int-%{version}.jar
install -p -m 644 spring-int/target/jboss-spring-int.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-spring-int-%{version}.jar
%endif
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%add_to_maven_depmap org.jboss.microcontainer %{oname} %{namedversion} JPP/%{name} %{oname}
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}.pom
%add_to_maven_depmap org.jboss.microcontainer jboss-kernel %{namedversion} JPP/%{name} jboss-kernel
install -p -m 644 kernel/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jboss-kernel.pom
%add_to_maven_depmap org.jboss.microcontainer jboss-dependency %{namedversion} JPP/%{name} jboss-dependency
install -p -m 644 dependency/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jboss-dependency.pom
%if %with integration
%add_to_maven_depmap org.jboss.microcontainer jboss-aop-mc-int %{namedversion} JPP/%{name} jboss-aop-mc-int
install -p -m 644 aop-mc-int/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jboss-aop-mc-int.pom
%add_to_maven_depmap org.jboss.microcontainer jboss-guice-int %{namedversion} JPP/%{name} jboss-guice-int
install -p -m 644 guice-int/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jboss-guice-int.pom
%add_to_maven_depmap org.jboss.microcontainer jboss-spring-int %{namedversion} JPP/%{name} jboss-spring-int
install -p -m 644 spring-int/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jboss-spring-int.pom
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
%if %with integration
install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
%else
install -p -m 644 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
%endif
install -p -m 644 %{PATCH3} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-dependency.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-dependency.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-kernel.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-kernel.jar
%if %with integration
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-mc-int.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-aop-mc-int.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-guice-int.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-guice-int.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-spring-int.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-spring-int.jar
%else
perl -pi -e 's/^.*jboss-aop-mc-int.jar.*\n$//g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
%endif
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{oname}.pom
install -p -m 644 kernel/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-kernel.pom
install -p -m 644 dependency/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-dependency.pom
%if %with integration
install -p -m 644 aop-mc-int/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-aop-mc-int.pom
install -p -m 644 guice-int/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-guice-int.pom
install -p -m 644 spring-int/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-spring-int.pom
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}*/%{name}/jboss-dependency-%{version}.jar
%{_javadir}*/%{name}/jboss-dependency.jar
%{_javadir}*/%{name}/jboss-kernel-%{version}.jar
%{_javadir}*/%{name}/jboss-kernel.jar
%{_javadir}*/%{name}/jboss-kernel-tests-%{version}.jar
%{_javadir}*/%{name}/jboss-kernel-tests.jar
%if %with integration
%{_javadir}*/%{name}/jboss-aop-mc-int-%{version}.jar
%{_javadir}*/%{name}/jboss-aop-mc-int.jar
%{_javadir}*/%{name}/jboss-guice-int-%{version}.jar
%{_javadir}*/%{name}/jboss-guice-int.jar
%{_javadir}*/%{name}/jboss-spring-int-%{version}.jar
%{_javadir}*/%{name}/jboss-spring-int.jar
%endif
%{_datadir}/maven2/poms/JPP.%{name}-jboss-dependency.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-kernel.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-microcontainer.pom
%if %with integration
%{_datadir}/maven2/poms/JPP.%{name}-jboss-aop-mc-int.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-guice-int.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-spring-int.pom
%endif
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Jan 19 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.10-5
- Add patch to fix jboss-parent version

* Fri Dec 03 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.10-4
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-surefire-provider-junit4, maven-site-plugin
- Change javadoc:javadoc to javadoc:aggregate
- Add patch to remove findbugs plugin

* Thu Jul 29 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.10-3
- Fix obsoletes

* Thu Jul 29 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.10-2
- Obsoletes jboss-microcontainer

* Wed May 26 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.10-1
- Upgrade to 2.0.10.GA
- Add patch to remove findbugs-maven-plugin

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.9-1.3.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhatc.om> 0:2.0.9-1.3
- Rebuild 
- Fix depmap entry for dtdparser 
- Add BR: jboss-profiler

* Wed Jan 27 2010 Yong Yang <yyang@redhat.com> 0:2.0.9-1.2.3
- Rebuild with integration enabled and bootstrap disabled

* Mon Jan 18 2010 Yong Yang <yyang@redhat.com> 0:2.0.9-1.2.2
- Comment BR: jboss-naming
- Build with pre-build jboss-test jar in RHEL-5-EP-5

* Fri Jan 15 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.9-1.2.1
- Set integration flag to false, to remove circular dependency to jboss-aop2

* Tue Sep 22 2009 Permaine Cheung <pcheung@redhat.com> 0:2.0.9-1.2
- Update component-info.xml

* Tue Sep 22 2009 Permaine Cheung <pcheung@redhat.com> 0:2.0.9-1.1
- Upgrade to 2.0.9

* Fri Aug 21 2009 David Walluck <dwalluck@redhat.com> 0:2.0.8-1.6
- remove version from jar names in repolib

* Fri Aug 21 2009 David Walluck <dwalluck@redhat.com> 0:2.0.8-1.5
- add integration jars to repolib

* Thu Aug 20 2009 David Walluck <dwalluck@redhat.com> 0:2.0.8-1.4
- copy correct patch based on integration status

* Thu Aug 20 2009 David Walluck <dwalluck@redhat.com> 0:2.0.8-1.3
- add poms to repolib

* Thu Aug 20 2009 David Walluck <dwalluck@redhat.com> 0:2.0.8-1.2
- fix bcond_without() macro

* Thu Aug 20 2009 David Walluck <dwalluck@redhat.com> 0:2.0.8-1.1
- enable integration

* Tue Aug 18 2009 Martha Benitez <mbenitez@redhat.com> 0:2.0.8-1
- Upgrade to 2.0.8.GA
- Add BR jboss-parent

* Tue Jul 21 2009 Martha Benitez <mbenitez@redhat.com> 0:2.0.7-1
- Upgrade to version 2.0.7

* Mon Jul 06 2009 Yong Yang <yyang@redhat.com> 0:2.0.6-4
- enable repolib

* Thu Jun 18 2009 David Walluck <dwalluck@redhat.com> 0:2.0.6-3
- build with jboss-aop2

* Thu Jun 18 2009 David Walluck <dwalluck@redhat.com> 0:2.0.6-2
- add repolib
- add int poms only if build with int

* Wed Jun 10 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.6-1.jpp5
- 2.0.6.GA

* Fri May 29 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.4-1.jpp5
- first release

